﻿local buffsname = {
--按名字或者法术id显示,法术id不需要双引号
"鲜血脓液",		--血池
373011,	--小伪装
373785,	--大伪装
373724,	--大伪装盾
229489,	--卡拉赞象棋国王减伤
--229495,	--卡拉赞象棋国王易伤
163689,	--钢铁码头二号boss盾
}

local function PCBN(name)
	for k,v in ipairs(buffsname) do
		if v == name then
			return true
		end
	end
end

local function PCPB(unit)
if not unit then return end
if UnitIsUnit("player", unit) then return end
if not PlateColorDB.dispelbuff then return end
if not UnitCanAttack("player",unit) then return end
local icon,count,dispelType,duration,expirationTime,icon2,count2,dispelType2,duration2,expirationTime2
local num
for i = 1,20 do
	local name1,icon1,count1,dispelType1,duration1,expirationTime1,_,_,_,spellid = UnitBuff(unit,i)
	if dispelType1 == "Magic" or dispelType1 == "" or PCBN(name1) or PCBN(spellid) then 
		icon,count,dispelType,duration,expirationTime = icon1,count1,dispelType1,duration1,expirationTime1
		if spellid == 373785 then icon = 1413862 end	--大伪装
		num = i
	break
	end
end
if num then
for j = num+1,20 do
	local name3,icon3,count3,dispelType3,duration3,expirationTime3,_,_,_,spellid3 = UnitBuff(unit,j)
	if dispelType3 == "Magic" or dispelType3 == "" or PCBN(name3) or PCBN(spellid3) then
		icon2,count2,dispelType2,duration2,expirationTime2 = icon3,count3,dispelType3,duration3,expirationTime3
		if spellid3 == 373785 then icon2 = 1413862 end	--大伪装
	break
	end
end
end
return icon,count,dispelType,duration,expirationTime,icon2,count2,dispelType2,duration2,expirationTime2
end

local function PlateBuffsDispel(nameplate)	
Np_Frame = nameplate.UnitFrame
--创建框架部分抄自rsplate
if not Np_Frame.StolenFrame then 
	Np_Frame.StolenFrame = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.StolenFrame:SetSize(30, 30)
	Np_Frame.StolenFrame:SetPoint("LEFT", Np_Frame.healthBar, "RIGHT", 3, 3)
	Np_Frame.StolenFrame:Hide()

	Np_Frame.StolenFrame.Texture = Np_Frame.StolenFrame:CreateTexture(nil, "OVERLAY")
	Np_Frame.StolenFrame.Texture:SetAllPoints()

	Np_Frame.StolenFrame.count = Np_Frame.StolenFrame:CreateFontString(nil, "ARTWORK")
	Np_Frame.StolenFrame.count:SetFont(STANDARD_TEXT_FONT, 20, 'OUTLINE')
	Np_Frame.StolenFrame.count:SetPoint("BOTTOM",Np_Frame.StolenFrame,"TOP",0,0)
	
	Np_Frame.StolenFrame.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.StolenFrame, "CooldownFrameTemplate")
	Np_Frame.StolenFrame.Cooldown:SetAllPoints()
	local regon = Np_Frame.StolenFrame.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, 15, "OUTLINE")
	end
	Np_Frame.StolenFrame.Cooldown:SetReverse(true)
end
if not Np_Frame.StolenFrame2 then 
	Np_Frame.StolenFrame2 = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.StolenFrame2:SetSize(30, 30)
	Np_Frame.StolenFrame2:SetPoint("LEFT", Np_Frame.healthBar, "RIGHT", 35, 3)
	Np_Frame.StolenFrame2:Hide()

	Np_Frame.StolenFrame2.Texture = Np_Frame.StolenFrame2:CreateTexture(nil, "OVERLAY")
	Np_Frame.StolenFrame2.Texture:SetAllPoints()

	Np_Frame.StolenFrame2.count = Np_Frame.StolenFrame2:CreateFontString(nil, "ARTWORK")
	Np_Frame.StolenFrame2.count:SetFont(STANDARD_TEXT_FONT, 20, 'OUTLINE')
	Np_Frame.StolenFrame2.count:SetPoint("BOTTOM",Np_Frame.StolenFrame2,"TOP",0,0)
	
	Np_Frame.StolenFrame2.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.StolenFrame2, "CooldownFrameTemplate")
	Np_Frame.StolenFrame2.Cooldown:SetAllPoints()
	local regon2 = Np_Frame.StolenFrame2.Cooldown:GetRegions()
	if regon2.GetText then 
	regon2:SetFont(STANDARD_TEXT_FONT, 15, "OUTLINE")
	end
	Np_Frame.StolenFrame2.Cooldown:SetReverse(true)
end

local icon,count,dispelType,duration,expirationTime,icon2,count2,dispelType2,duration2,expirationTime2 = PCPB(nameplate.UnitFrame.unit)
if icon then 	
	Np_Frame.StolenFrame:Show()
	Np_Frame.StolenFrame.Texture:SetTexture(icon)
	Np_Frame.StolenFrame.Cooldown:SetCooldown(expirationTime - duration, duration)
	if (expirationTime-GetTime())>99 then
		Np_Frame.StolenFrame.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.StolenFrame.Cooldown:SetHideCountdownNumbers(false)
	end
	if count > 1 then
		Np_Frame.StolenFrame.count:SetText(count)
	else
		Np_Frame.StolenFrame.count:SetText(nil)
	end
	if IsAddOnLoaded("WeakAuras") then
		if dispelType == "Magic" then
			LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame,{0,1,0,1},nil,.25,nil,2) 
		elseif dispelType == "" then
			LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame,{1,0,0,1},nil,.25,nil,2) 
		else
			LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame,{1,1,1,1},nil,.25,nil,2) 
		end
	end
else
	Np_Frame.StolenFrame.Texture:SetTexture(nil)
	Np_Frame.StolenFrame:Hide()
end

if icon2 then 
	Np_Frame.StolenFrame2:Show()
	Np_Frame.StolenFrame2.Texture:SetTexture(icon2)
	Np_Frame.StolenFrame2.Cooldown:SetCooldown(expirationTime2 - duration2, duration2)
	if (expirationTime2-GetTime())>99 then
		Np_Frame.StolenFrame2.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.StolenFrame2.Cooldown:SetHideCountdownNumbers(false)
	end
	if count2 > 1 then
		Np_Frame.StolenFrame2.count:SetText(count2)
	else
		Np_Frame.StolenFrame2.count:SetText(nil)
	end
	if IsAddOnLoaded("WeakAuras") then
		if dispelType2 == "Magic" then
			LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame2,{0,1,0,1},nil,.25,nil,2) 
		elseif dispelType2 == "" then
			LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame2,{1,0,0,1},nil,.25,nil,2) 
		else
			LibStub("LibCustomGlow-1.0").PixelGlow_Start(Np_Frame.StolenFrame2,{1,1,1,1},nil,.25,nil,2) 
		end
	end
else
	Np_Frame.StolenFrame2.Texture:SetTexture(nil)
	Np_Frame.StolenFrame2:Hide()
end
end

local framebuff = CreateFrame('Frame')
framebuff:RegisterEvent("UNIT_AURA")
framebuff:RegisterEvent("NAME_PLATE_UNIT_ADDED")
framebuff:SetScript('OnEvent', function(self, event, namePlateUnitToken)
if namePlateUnitToken:lower():match("nameplate") then
local namePlate = C_NamePlate.GetNamePlateForUnit(namePlateUnitToken,false)
if not namePlate then return end
if namePlate:IsForbidden() then return end
PlateBuffsDispel(namePlate)
end
end)
