﻿local buffsname = {
--按名字或者法术id显示,法术id不需要双引号
"变形术",
"忏悔",
"闷棍",
"恐惧",
"冰冻陷阱",
"妖术",
"冰霜新兴",


}

local function PCBN(name)
	for k,v in ipairs(buffsname) do
		if v == name then
			return true
		end
	end
end

local function PCPB(unit)
if not unit then return end
if UnitIsUnit("player", unit) then return end
if PlateColorDB.hidebuff then return end
--if not UnitCanAttack("player",unit) then return end
local a0,a1,a2,a3,a4,a5,a6,a7,b0,b1,b2,b3,b4,b5,b6,b7,c0,c1,c2,c3,c4,c5,c6,c7,d0,d1,d2,d3,d4,d5,d6,d7,e0,e1,e2,e3,e4,e5,e6,e7,f0,f1,f2,f3,f4,f5,f6,f7
--0名字,1材质,2层数,3剩余时间,4结束时间,5来源,6法术id,7所有
local num,num2,num3,num4,num5
for i = 1,20 do
	local a00,a11,a22,_,a33,a44,a55,_,_,a66,_,_,_,a77 = UnitDebuff(unit,i)	
	if (a55 == "player" or PlateColorDB.DctAura[a66] or PCBN(a00) or PCBN(a66)) and not PlateColorDB.blackAura[a66] then 
		a0,a1,a2,a3,a4,a5,a6,a7 = a00,a11,a22,a33,a44,a55,a66,a77
		num = i
		break
	end
end
if num then
for j = num+1,20 do
	local b00,b11,b22,_,b33,b44,b55,_,_,b66,_,_,_,b77 = UnitDebuff(unit,j)
	if (b55 == "player" or PlateColorDB.DctAura[b66] or PCBN(b00) or PCBN(b66)) and not PlateColorDB.blackAura[b66] then 
		b0,b1,b2,b3,b4,b5,b6,b7 = b00,b11,b22,b33,b44,b55,b66,b77
		num2 = j
		break
	end
end
end
if num2 then
for k = num2+1,20 do
	local c00,c11,c22,_,c33,c44,c55,_,_,c66,_,_,_,c77 = UnitDebuff(unit,k)
	if (c55 == "player" or PlateColorDB.DctAura[c66] or PCBN(c00) or PCBN(c66)) and not PlateColorDB.blackAura[c66] then 
		c0,c1,c2,c3,c4,c5,c6,c7 = c00,c11,c22,c33,c44,c55,c66,c77
		num3 = k
		break
	end
end
end
if num3 then
for l = num3+1,20 do
	local d00,d11,d22,_,d33,d44,d55,_,_,d66,_,_,_,d77 = UnitDebuff(unit,l)
	if (d55 == "player" or PlateColorDB.DctAura[d66] or PCBN(d00) or PCBN(d66)) and not PlateColorDB.blackAura[d66] then 
		d0,d1,d2,d3,d4,d5,d6,d7 = d00,d11,d22,d33,d44,d55,d66,d77
		num4 = l
		break
	end
end
end
if num4 then
for m = num4+1,20 do
	local e00,e11,e22,_,e33,e44,e55,_,_,e66,_,_,_,e77 = UnitDebuff(unit,m)
	if (e55 == "player" or PlateColorDB.DctAura[e66] or PCBN(e00) or PCBN(e66)) and not PlateColorDB.blackAura[e66] then 
		e0,e1,e2,e3,e4,e5,e6,e7 = e00,e11,e22,e33,e44,e55,e66,e77
		num5 = m
		break
	end
end
end
if num5 then
for n = num4+1,20 do
	local f00,f11,f22,_,f33,f44,f55,_,_,f66,_,_,_,f77 = UnitDebuff(unit,n)
	if (f55 == "player" or PlateColorDB.DctAura[f66] or PCBN(f00) or PCBN(f66)) and not PlateColorDB.blackAura[f66] then 
		f0,f1,f2,f3,f4,f5,f6,f7 = f00,f11,f22,f33,f44,f55,f66,f77
		break
	end
end
end

return a0,a1,a2,a3,a4,a5,a6,a7,b0,b1,b2,b3,b4,b5,b6,b7,c0,c1,c2,c3,c4,c5,c6,c7,d0,d1,d2,d3,d4,d5,d6,d7,e0,e1,e2,e3,e4,e5,e6,e7,f0,f1,f2,f3,f4,f5,f6,f7
end

local function PlateBuffsDispel(nameplate)	
local xx = PlateColorDB.buffz-5
Np_Frame = nameplate.UnitFrame
--创建框架部分抄自rsplate
if not Np_Frame.DebuffFrame then 
	Np_Frame.DebuffFrame = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.DebuffFrame:SetSize(xx, xx)
	Np_Frame.DebuffFrame:SetPoint("BOTTOMLEFT", Np_Frame.healthBar, "TOPLEFT", 0, 15)
	Np_Frame.DebuffFrame:Hide()

	Np_Frame.DebuffFrame.Texture = Np_Frame.DebuffFrame:CreateTexture(nil, "OVERLAY")
	Np_Frame.DebuffFrame.Texture:SetAllPoints()

	Np_Frame.DebuffFrame.count = Np_Frame.DebuffFrame:CreateFontString(nil, "OVERLAY")
	Np_Frame.DebuffFrame.count:SetFont(STANDARD_TEXT_FONT, xx/2, 'OUTLINE')
	Np_Frame.DebuffFrame.count:SetPoint("BOTTOMRIGHT",Np_Frame.DebuffFrame,"BOTTOMRIGHT",3,-3)
	
	Np_Frame.DebuffFrame.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.DebuffFrame, "CooldownFrameTemplate")
	Np_Frame.DebuffFrame.Cooldown:SetAllPoints()
	local regon = Np_Frame.DebuffFrame.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, xx/1.5, "OUTLINE")
	end
	Np_Frame.DebuffFrame.Cooldown:SetReverse(true)
end
if not Np_Frame.DebuffFrame2 then 
	Np_Frame.DebuffFrame2 = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.DebuffFrame2:SetSize(xx, xx)
	Np_Frame.DebuffFrame2:SetPoint("LEFT", Np_Frame.DebuffFrame, "RIGHT", 2, 0)
	Np_Frame.DebuffFrame2:Hide()

	Np_Frame.DebuffFrame2.Texture = Np_Frame.DebuffFrame2:CreateTexture(nil, "OVERLAY")
	Np_Frame.DebuffFrame2.Texture:SetAllPoints()

	Np_Frame.DebuffFrame2.count = Np_Frame.DebuffFrame2:CreateFontString(nil, "OVERLAY")
	Np_Frame.DebuffFrame2.count:SetFont(STANDARD_TEXT_FONT, xx/2, 'OUTLINE')
	Np_Frame.DebuffFrame2.count:SetPoint("BOTTOMRIGHT",Np_Frame.DebuffFrame2,"BOTTOMRIGHT",3,-3)
	
	Np_Frame.DebuffFrame2.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.DebuffFrame2, "CooldownFrameTemplate")
	Np_Frame.DebuffFrame2.Cooldown:SetAllPoints()
	local regon = Np_Frame.DebuffFrame2.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, xx/1.5, "OUTLINE")
	end
	Np_Frame.DebuffFrame2.Cooldown:SetReverse(true)
end
if not Np_Frame.DebuffFrame3 then 
	Np_Frame.DebuffFrame3 = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.DebuffFrame3:SetSize(xx, xx)
	Np_Frame.DebuffFrame3:SetPoint("LEFT", Np_Frame.DebuffFrame2, "RIGHT", 2, 0)
	Np_Frame.DebuffFrame3:Hide()

	Np_Frame.DebuffFrame3.Texture = Np_Frame.DebuffFrame3:CreateTexture(nil, "OVERLAY")
	Np_Frame.DebuffFrame3.Texture:SetAllPoints()

	Np_Frame.DebuffFrame3.count = Np_Frame.DebuffFrame3:CreateFontString(nil, "OVERLAY")
	Np_Frame.DebuffFrame3.count:SetFont(STANDARD_TEXT_FONT, xx/2, 'OUTLINE')
	Np_Frame.DebuffFrame3.count:SetPoint("BOTTOMRIGHT",Np_Frame.DebuffFrame3,"BOTTOMRIGHT",3,-3)
	
	Np_Frame.DebuffFrame3.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.DebuffFrame3, "CooldownFrameTemplate")
	Np_Frame.DebuffFrame3.Cooldown:SetAllPoints()
	local regon = Np_Frame.DebuffFrame3.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, xx/1.5, "OUTLINE")
	end
	Np_Frame.DebuffFrame3.Cooldown:SetReverse(true)
end
if not Np_Frame.DebuffFrame4 then 
	Np_Frame.DebuffFrame4 = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.DebuffFrame4:SetSize(xx, xx)
	Np_Frame.DebuffFrame4:SetPoint("LEFT", Np_Frame.DebuffFrame3, "RIGHT", 2, 0)
	Np_Frame.DebuffFrame4:Hide()

	Np_Frame.DebuffFrame4.Texture = Np_Frame.DebuffFrame4:CreateTexture(nil, "OVERLAY")
	Np_Frame.DebuffFrame4.Texture:SetAllPoints()

	Np_Frame.DebuffFrame4.count = Np_Frame.DebuffFrame4:CreateFontString(nil, "OVERLAY")
	Np_Frame.DebuffFrame4.count:SetFont(STANDARD_TEXT_FONT, xx/2, 'OUTLINE')
	Np_Frame.DebuffFrame4.count:SetPoint("BOTTOMRIGHT",Np_Frame.DebuffFrame4,"BOTTOMRIGHT",3,-3)
	
	Np_Frame.DebuffFrame4.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.DebuffFrame4, "CooldownFrameTemplate")
	Np_Frame.DebuffFrame4.Cooldown:SetAllPoints()
	local regon = Np_Frame.DebuffFrame4.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, xx/1.5, "OUTLINE")
	end
	Np_Frame.DebuffFrame4.Cooldown:SetReverse(true)
end
if not Np_Frame.DebuffFrame5 then 
	Np_Frame.DebuffFrame5 = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.DebuffFrame5:SetSize(xx, xx)
	Np_Frame.DebuffFrame5:SetPoint("LEFT", Np_Frame.DebuffFrame4, "RIGHT", 2, 0)
	Np_Frame.DebuffFrame5:Hide()

	Np_Frame.DebuffFrame5.Texture = Np_Frame.DebuffFrame5:CreateTexture(nil, "OVERLAY")
	Np_Frame.DebuffFrame5.Texture:SetAllPoints()

	Np_Frame.DebuffFrame5.count = Np_Frame.DebuffFrame5:CreateFontString(nil, "OVERLAY")
	Np_Frame.DebuffFrame5.count:SetFont(STANDARD_TEXT_FONT, xx/2, 'OUTLINE')
	Np_Frame.DebuffFrame5.count:SetPoint("BOTTOMRIGHT",Np_Frame.DebuffFrame5,"BOTTOMRIGHT",3,-3)
	
	Np_Frame.DebuffFrame5.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.DebuffFrame5, "CooldownFrameTemplate")
	Np_Frame.DebuffFrame5.Cooldown:SetAllPoints()
	local regon = Np_Frame.DebuffFrame5.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, xx/1.5, "OUTLINE")
	end
	Np_Frame.DebuffFrame5.Cooldown:SetReverse(true)
end
if not Np_Frame.DebuffFrame6 then 
	Np_Frame.DebuffFrame6 = CreateFrame("Frame", nil, Np_Frame.healthBar)
	Np_Frame.DebuffFrame6:SetSize(xx, xx)
	Np_Frame.DebuffFrame6:SetPoint("LEFT", Np_Frame.DebuffFrame4, "RIGHT", 2, 0)
	Np_Frame.DebuffFrame6:Hide()

	Np_Frame.DebuffFrame6.Texture = Np_Frame.DebuffFrame6:CreateTexture(nil, "OVERLAY")
	Np_Frame.DebuffFrame6.Texture:SetAllPoints()

	Np_Frame.DebuffFrame6.count = Np_Frame.DebuffFrame6:CreateFontString(nil, "OVERLAY")
	Np_Frame.DebuffFrame6.count:SetFont(STANDARD_TEXT_FONT, xx/2, 'OUTLINE')
	Np_Frame.DebuffFrame6.count:SetPoint("BOTTOMRIGHT",Np_Frame.DebuffFrame6,"BOTTOMRIGHT",3,-3)
	
	Np_Frame.DebuffFrame6.Cooldown = CreateFrame("Cooldown", nil, Np_Frame.DebuffFrame6, "CooldownFrameTemplate")
	Np_Frame.DebuffFrame6.Cooldown:SetAllPoints()
	local regon = Np_Frame.DebuffFrame6.Cooldown:GetRegions()
	if regon.GetText then 
	regon:SetFont(STANDARD_TEXT_FONT, xx/1.5, "OUTLINE")
	end
	Np_Frame.DebuffFrame6.Cooldown:SetReverse(true)
end

local a0,a1,a2,a3,a4,a5,a6,a7,b0,b1,b2,b3,b4,b5,b6,b7,c0,c1,c2,c3,c4,c5,c6,c7,d0,d1,d2,d3,d4,d5,d6,d7,e0,e1,e2,e3,e4,e5,e6,e7 = PCPB(nameplate.UnitFrame.unit)
--0名字,1材质,2层数,3剩余时间,4结束时间,5个人,6法术id,7所有
if a1 then 	
	Np_Frame.DebuffFrame:Show()
	Np_Frame.DebuffFrame.Texture:SetTexture(a1)
	Np_Frame.DebuffFrame.Cooldown:SetCooldown(a4 - a3, a3)
	if (a4-GetTime())>99 then
		Np_Frame.DebuffFrame.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.DebuffFrame.Cooldown:SetHideCountdownNumbers(false)
	end
	if a2 > 1 then
		Np_Frame.DebuffFrame.count:SetText(a2)
	else
		Np_Frame.DebuffFrame.count:SetText(nil)
	end
else
	Np_Frame.DebuffFrame.Texture:SetTexture(nil)
	Np_Frame.DebuffFrame:Hide()
end
if b1 then 	
	Np_Frame.DebuffFrame2:Show()
	Np_Frame.DebuffFrame2.Texture:SetTexture(b1)
	Np_Frame.DebuffFrame2.Cooldown:SetCooldown(b4 - b3, b3)
	if (b4-GetTime())>99 then
		Np_Frame.DebuffFrame2.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.DebuffFrame2.Cooldown:SetHideCountdownNumbers(false)
	end
	if b2 > 1 then
		Np_Frame.DebuffFrame2.count:SetText(b2)
	else
		Np_Frame.DebuffFrame2.count:SetText(nil)
	end
else
	Np_Frame.DebuffFrame2.Texture:SetTexture(nil)
	Np_Frame.DebuffFrame2:Hide()
end
if c1 then 	
	Np_Frame.DebuffFrame3:Show()
	Np_Frame.DebuffFrame3.Texture:SetTexture(c1)
	Np_Frame.DebuffFrame3.Cooldown:SetCooldown(c4 - c3, c3)
	if (c4-GetTime())>99 then
		Np_Frame.DebuffFrame3.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.DebuffFrame3.Cooldown:SetHideCountdownNumbers(false)
	end
	if c2 > 1 then
		Np_Frame.DebuffFrame3.count:SetText(c2)
	else
		Np_Frame.DebuffFrame3.count:SetText(nil)
	end
else
	Np_Frame.DebuffFrame3.Texture:SetTexture(nil)
	Np_Frame.DebuffFrame3:Hide()
end
if d1 then 	
	Np_Frame.DebuffFrame4:Show()
	Np_Frame.DebuffFrame4.Texture:SetTexture(d1)
	Np_Frame.DebuffFrame4.Cooldown:SetCooldown(d4 - d3, d3)
	if (d4-GetTime())>99 then
		Np_Frame.DebuffFrame4.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.DebuffFrame4.Cooldown:SetHideCountdownNumbers(false)
	end
	if d2 > 1 then
		Np_Frame.DebuffFrame4.count:SetText(d2)
	else
		Np_Frame.DebuffFrame4.count:SetText(nil)
	end
else
	Np_Frame.DebuffFrame4.Texture:SetTexture(nil)
	Np_Frame.DebuffFrame4:Hide()
end
if e1 then 	
	Np_Frame.DebuffFrame5:Show()
	Np_Frame.DebuffFrame5.Texture:SetTexture(e1)
	Np_Frame.DebuffFrame5.Cooldown:SetCooldown(e4 - e3, e3)
	if (e4-GetTime())>99 then
		Np_Frame.DebuffFrame5.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.DebuffFrame5.Cooldown:SetHideCountdownNumbers(false)
	end
	if e2 > 1 then
		Np_Frame.DebuffFrame5.count:SetText(e2)
	else
		Np_Frame.DebuffFrame5.count:SetText(nil)
	end
else
	Np_Frame.DebuffFrame5.Texture:SetTexture(nil)
	Np_Frame.DebuffFrame5:Hide()
end
if f1 then 	
	Np_Frame.DebuffFrame6:Show()
	Np_Frame.DebuffFrame6.Texture:SetTexture(f1)
	Np_Frame.DebuffFrame6.Cooldown:SetCooldown(f4 - f3, f3)
	if (f4-GetTime())>99 then
		Np_Frame.DebuffFrame6.Cooldown:SetHideCountdownNumbers(true)
	else
		Np_Frame.DebuffFrame6.Cooldown:SetHideCountdownNumbers(false)
	end
	if f2 > 1 then
		Np_Frame.DebuffFrame6.count:SetText(f2)
	else
		Np_Frame.DebuffFrame6.count:SetText(nil)
	end
else
	Np_Frame.DebuffFrame6.Texture:SetTexture(nil)
	Np_Frame.DebuffFrame6:Hide()
end
end

local framebuff = CreateFrame('Frame')
framebuff:RegisterEvent("UNIT_AURA")
framebuff:RegisterEvent("NAME_PLATE_UNIT_ADDED")
framebuff:SetScript('OnEvent', function(self, event, namePlateUnitToken)
if namePlateUnitToken:lower():match("nameplate") then
local namePlate = C_NamePlate.GetNamePlateForUnit(namePlateUnitToken,false)
if not namePlate then return end
if namePlate:IsForbidden() then return end
PlateBuffsDispel(namePlate)
end
end)
